<?php
class UserObj{
	public $UserID;
	public $EffectiveDate;
	public $Remark;
}

class WebServices
{
	private $wsdl;
	private $namespace;
	private $soapHeader;
	private $client;
	private $securityToken;
	private $status;
	private $password;
	private $companyid;
	private $companyuserid;
	private $licenseid;
	private $LicenseObj;
	private $WebLoginUrl;
	
	public function __construct($wsdl, $namespace="")
	{
		$this->wsdl = $wsdl;
		$this->namespace = $namespace;
		$this->createWebServices();
	}
	
	// FUNCTION
	public function createWebServices()
	{
		//instantiate the SOAP client
		$this->client = new SoapClient($this->wsdl);
	}
	
	public function setHeader()
	{
		$this->client->__setSoapHeaders(NULL);
		
		$auth = array(
         'SecurityToken'=>$this->getSecurityToken()
         );
		$header = new SoapHeader($this->namespace,'WebServiceSoapHeader',$auth,false);
		$this->client->__setSoapHeaders(array($header));
	}
	
	public function WebServiceLogin($username, $password)
	{
		$resultObj = json_decode($this->client->WebServiceLogin(array('Username'=>$username, 'Password'=>$password))->WebServiceLoginResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setSecurityToken($result->SecurityToken);
		
		//return $errorMessage;
		return $resultObj;
	}
	
	public function WebServiceLogout()
	{
		$this->setHeader();

		$resultObj = json_decode($this->client->WebServiceLogout(array('ST'=>$this->getSecurityToken()))->WebServiceLogoutResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		
		return $errorMessage;
	}
	
	public function GetCompanyID()
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetCompanyID()->GetCompanyIDResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setCompanyID($result->CompanyID);
		//var_dump($result->UserInfoObj);
		
		return $resultObj;
	}
	
	public function GetUserInfo($CompanyID, $UserID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetUserInfo(array('CompanyID' => $CompanyID, 'UserID'=> $UserID))->GetUserInfoResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setUserInfoObj($result->UserInfoObj);
		//var_dump($result->UserInfoObj);
		
		return $resultObj;
	}

	public function GetUserInfoByEmail($CompanyID, $Email)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetUserInfoByEmail(array('CompanyID' => $CompanyID,'Email' => $Email))->GetUserInfoByEmailResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setUserInfoObj($result->UserInfoObj);
		//var_dump($result->UserInfoObj);
		
		return $resultObj;
	}
	
	public function GetAllUserInfo($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllUserInfo(array('CompanyID' => $CompanyID))->GetAllUserInfoResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setUsersObj($result->UsersObj);
		//var_dump($result->UsersObj);
		
		return $resultObj;
	}
	
	public function GetAvailableLicense($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAvailableLicense(array('CompanyID' => $CompanyID))->GetAvailableLicenseResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setLicenseObj($result->LicenseObj);
		//var_dump($result->LicenseObj);
		
		return $resultObj;
	}
	
	public function GetTerminalUserInfo($CompanyID, $SerialNo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetTerminalUserInfo(array('CompanyID' => $CompanyID, 'SerialNo' => $SerialNo))->GetTerminalUserInfoResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setTerminalUserInfoObj($result->TerminalUserInfoObj);
		//var_dump($result->TerminalUserInfoObj);
		
		return $resultObj;
	}
	
	public function GetAllTerminalUserInfo($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllTerminalUserInfo(array('CompanyID' => $CompanyID))->GetAllTerminalUserInfoResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllTerminalUserInfoObj($result->AllTerminalUserInfoObj);
		//var_dump($result->setAllTerminalUserInfoObj);
		
		return $resultObj;
	}
	
	public function GetLog($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetLog(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetLogResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setLogObj($result->LogObj);
		//var_dump($result->LogObj);
		
		return $resultObj;
	}
	
	public function GetAllLog($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllLog(array('CompanyID' => $CompanyID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAllLogResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllLogsObj($result->AllLogsObj);
		//var_dump($result->AllLogsObj);
		
		return $resultObj;
	}
	public function GetTerminalInfo($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetTerminalInfo(array('CompanyID' => $CompanyID))->GetTerminalInfoResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setTerminalInfoObj($result->TerminalInfoObj);
		//var_dump($result->TerminalInfoObj);
		
		return $resultObj;
	}
	public function GetApiLimit($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetApiLimit(array('CompanyID' => $CompanyID))->GetApiLimitResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setApiLimitObj($result->ApiLimitObj);
		//var_dump($result->ApiLimitObj);
		
		return $resultObj;
	}
	public function GetFingerprint($CompanyID, $UserID, $AlgoVer)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetFingerprint(array('CompanyID' => $CompanyID, 'UserID'=> $UserID, 'AlgoVer'=> $AlgoVer))->GetFingerprintResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setFingerprintObj($result->FingerprintObj);
		//var_dump($result->FingerprintObj);
		
		return $resultObj;
	}
	public function GetAuditData($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAuditData(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAuditDataResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAuditDataObj($result->AuditDataObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}	
	
	public function GetAuditDataByClockingMethod($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $ClockingMethod, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAuditDataByClockingMethod(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'ClockingMethod' => $ClockingMethod, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAuditDataByClockingMethodResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAuditDataObj($result->AuditDataObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}	
	
	public function GetApprovedOT($CompanyID, $ApprovedDateFrom, $ApprovedDateTo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetApprovedOT(array('CompanyID' => $CompanyID, 'ApprovedDateFrom' => $ApprovedDateFrom, 'ApprovedDateTo' => $ApprovedDateTo))->GetApprovedOTResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		//$this->setAttendanceObj($result->ApprovedOT);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}

	public function GetApprovedSumWorkingHour($CompanyID, $UserID, $EmployeeID, $ApprovedDateFrom, $ApprovedDateTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetApprovedSumWorkingHour(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'EmployeeID' => $EmployeeID, 'ApprovedDateFrom' => $ApprovedDateFrom, 'ApprovedDateTo' => $ApprovedDateTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetApprovedSumWorkingHourResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setApprovedSumWorkingHourObj($result->ApprovedSumWorkingHourObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}
		
	public function GetAttendance($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAttendance(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAttendanceResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAttendanceObj($result->AttendanceObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}
	
	public function GetApprovedAttendance($CompanyID, $UserID, $EmployeeID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetApprovedAttendance(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'EmployeeID' => $EmployeeID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetApprovedAttendanceResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setApprovedAttendanceObj($result->AttendanceObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}

	public function GetAllAttendance($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllAttendance(array('CompanyID' => $CompanyID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAllAttendanceResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllAttendanceObj($result->AllAttendanceObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}
	
	public function GetAllApprovedAttendance($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllApprovedAttendance(array('CompanyID' => $CompanyID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAllApprovedAttendanceResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllApprovedAttendanceObj($result->AllAttendanceObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}

	public function GetAttendanceJobCost($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAttendanceJobCost(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAttendanceJobCostResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAttendanceJobCostObj($result->AttendanceJobCostObj);
		
		return $resultObj;
	}
	
	public function GetAllAttendanceJobCost($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllAttendanceJobCost(array('CompanyID' => $CompanyID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAllAttendanceJobCostResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllAttendanceJobCostObj($result->AllAttendanceJobCostObj);
		//var_dump($result->AuditDataObj);
		
		return $resultObj;
	}
	
	public function GetLeaveType($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetLeaveType(array('CompanyID' => $CompanyID))->GetLeaveTypeResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setLeaveTypeObj($result->LeaveTypeObj);
		
		return $resultObj;
	}
	
	public function GetUserLeave($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetUserLeave(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'CheckTimeFrom' => $CheckTimeFrom, 'CheckTimeTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetUserLeaveResult);

		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setUserLeaveObj($result->UserLeaveObj);
		
		return $resultObj;
	}
	
	public function AddLeaveType($CompanyID, $LeaveType)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddLeaveType(array('CompanyID' => $CompanyID, 'LeaveType' => $LeaveType))->AddLeaveTypeResult);

		return $resultObj;
	}
	
	public function UpdateLeaveType($CompanyID, $AutoNo, $LeaveType)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateLeaveType(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'LeaveType' => $LeaveType))->UpdateLeaveTypeResult);

		return $resultObj;
	}
	
	public function SetUserLeave($CompanyID, $UserID, $LeaveType, $DateFrom, $DateTo, $LeaveHour)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->SetUserLeave(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'LeaveType' => $LeaveType, 'DateFrom' => $DateFrom, 'DateTo' => $DateTo, 'LeaveHour' => $LeaveHour))->SetUserLeaveResult);

		return $resultObj;
	}
	
	public function SetUserLeave2($CompanyID, $JsonUserLeave)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->SetUserLeave2(array('CompanyID' => $CompanyID, 'JSONUserLeave' => $JsonUserLeave))->SetUserLeave2Result);

		return $resultObj;
	}
	
	public function AddUser($CompanyID, $Name, $Alias, $Gender, $DOB, $Nationality, $Race, $NationalID, $Religion, $HomeAddress, $MobileContact, $Email, $EmploymentID, $Designation, $SocialSecurityID, $JoinedDate, $Branch, $Department, $Section, $GroupDutyRoster, $RateHour, $TimeZone, $Remark, $TimeTecUserID, $TimeTecAccountIssuanceDate, $AccExpiryDate, $DivisionID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddUser(array('CompanyID' => $CompanyID, 'Name' => $Name, 'Alias' => $Alias, 'Gender' => $Gender, 'DOB' => $DOB, 'Nationality' => $Nationality, 'Race' => $Race, 'NationalID' => $NationalID, 'Religion' => $Religion, 'HomeAddress' => $HomeAddress, 'MobileContact' => $MobileContact, 'Email' => $Email, 'EmploymentID' => $EmploymentID, 'Designation' => $Designation, 'SocialSecurityID' => $SocialSecurityID, 'JoinedDate' => $JoinedDate, 'Branch' => $Branch, 'Department' => $Department, 'Section' => $Section, 'GroupDutyRoster' => $GroupDutyRoster, 'RateHour' => $RateHour, 'TimeZone' => $TimeZone, 'Remark' => $Remark, 'TimeTecUserID' => $TimeTecUserID, 'TimeTecAccountIssuanceDate' => $TimeTecAccountIssuanceDate, 'AccExpiryDate' => $AccExpiryDate , 'DivisionId' => $DivisionID))->AddUserResult);

		return $resultObj;
	}

	public function AddUser2($CompanyID, $JSONUserInfo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddUser2(array('CompanyID' => $CompanyID, 'JSONUserInfo' => $JSONUserInfo))->AddUser2Result);

		return $resultObj;
	}

	public function UpdateUser($CompanyID, $UserID, $Name, $Alias, $Gender, $DOB, $Nationality, $Race, $NationalID, $Religion, $HomeAddress, $MobileContact, $Email, $EmploymentID, $Designation, $SocialSecurityID, $JoinedDate, $Branch, $Department, $Section, $GroupDutyRoster, $RateHour, $TimeZone, $Remark, $TimeTecAccountIssuanceDate, $AccExpiryDate, $DivisionID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->UpdateUser(array('CompanyID' => $CompanyID, 'TimeTecUserID' => $UserID, 'Name' => $Name, 'Alias' => $Alias, 'Gender' => $Gender, 'DOB' => $DOB, 'Nationality' => $Nationality, 'Race' => $Race, 'NationalID' => $NationalID, 'Religion' => $Religion, 'HomeAddress' => $HomeAddress, 'MobileContact' => $MobileContact, 'Email' => $Email, 'EmploymentID' => $EmploymentID, 'Designation' => $Designation, 'SocialSecurityID' => $SocialSecurityID, 'JoinedDate' => $JoinedDate, 'Branch' => $Branch, 'Department' => $Department, 'Section' => $Section, 'GroupDutyRoster' => $GroupDutyRoster, 'RateHour' => $RateHour, 'TimeZone' => $TimeZone, 'Remark' => $Remark, 'TimeTecAccountIssuanceDate' => $TimeTecAccountIssuanceDate, 'AccExpiryDate' => $AccExpiryDate, 'DivisionId' => $DivisionID))->UpdateUserResult);
		return $resultObj;
	}
	
	public function UpdateUser2($CompanyID, $JSONUserInfo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateUser2(array('CompanyID' => $CompanyID, 'JSONUserInfo' => $JSONUserInfo))->UpdateUser2Result);

		return $resultObj;
	}

	public function UpdateUserStatus($CompanyID, $Status, $UserList)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->UpdateUserStatus(array('CompanyID' => $CompanyID, 'Status' => $Status, 'UserList' => $UserList))->UpdateUserStatusResult);
		return $resultObj;
	}
	
	public function GetSchedule($CompanyID, $ScheNo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetSchedule(array('CompanyID' => $CompanyID, 'ScheNo' => $ScheNo))->GetScheduleResult);
		
		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setScheduleObj($result->ScheduleObj);
		
		return $resultObj;
	}
	
	public function GetAllSchedule($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllSchedule(array('CompanyID' => $CompanyID))->GetAllScheduleResult);
		
		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setAllScheduleObj($result->AllScheduleObj);
		
		return $resultObj;
	}
	
	public function GetCompanySetting($CompanyID)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetCompanySetting(array('CompanyID' => $CompanyID))->GetCompanySettingResult);
		
		// Error Message
		$errorMessage = $resultObj->ErrorMessage;

		// Result
		$result = $resultObj->Result;
		$this->setStatus($result->Status);
		$this->setCompanySettingObj($result->CompanySettingObj);
		
		return $resultObj;
	}
	
	public function UpdateCompanySetting($CompanyID, $CompanyName, $Phone, $Fax, $CompanyEmail, $Address, $Country, $ContactPerson, $DateFormat, $TimeFormat, $HourFormat, $TimeZone, $PayrollCycle, $PreferredLanguage, $AllowSupportLogin, $Calendar, $FirstDayOfWeek, $CurrencySymbol, $GridSize, $Timeout, $PayrollCycleStartDate)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateCompanySetting(array('CompanyID' => $CompanyID, 'CompanyName' => $CompanyName, 'Phone' => $Phone, 'Fax' => $Fax, 'CompanyEmail' => $CompanyEmail, 'Address' => $Address, 'Country' => $Country, 'ContactPerson' => $ContactPerson, 'DateFormat' => $DateFormat, 'TimeFormat' => $TimeFormat, 'HourFormat' => $HourFormat, 'TimeZone' => $TimeZone, 'PayrollCycle' => $PayrollCycle, 'PreferredLanguage' => $PreferredLanguage, 'AllowSupportLogin' => $AllowSupportLogin, 'Calendar' => $Calendar, 'FirstDayOfWeek' => $FirstDayOfWeek, 'CurrencySymbol' => $CurrencySymbol, 'GridSize' => $GridSize, 'Timeout' => $Timeout, 'PayrollCycleStartDate' => $PayrollCycleStartDate))->UpdateCompanySettingResult);

		return $resultObj;
	}
	
	public function GetBranch($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetBranch(array('CompanyID' => $CompanyID))->GetBranchResult);
		return $resultObj;
	}
	
	public function AddBranch($CompanyID, $Branch)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddBranch(array('CompanyID' => $CompanyID, 'Branch' => $Branch))->AddBranchResult);

		return $resultObj;
	}
	
	public function UpdateBranch($CompanyID, $AutoNo, $Branch)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateBranch(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'Branch' => $Branch))->UpdateBranchResult);

		return $resultObj;
	}
		
	public function GetDepartment($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetDepartment(array('CompanyID' => $CompanyID))->GetDepartmentResult);
		return $resultObj;
	}
	
	public function AddDepartment($CompanyID, $Department)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddDepartment(array('CompanyID' => $CompanyID, 'Department' => $Department))->AddDepartmentResult);

		return $resultObj;
	}
	
	public function UpdateDepartment($CompanyID, $AutoNo, $Department)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateDepartment(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'Department' => $Department))->UpdateDepartmentResult);

		return $resultObj;
	}
			
	public function GetSection($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetSection(array('CompanyID' => $CompanyID))->GetSectionResult);
		return $resultObj;
	}
	
	public function AddSection($CompanyID, $Section)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddSection(array('CompanyID' => $CompanyID, 'Section' => $Section))->AddSectionResult);

		return $resultObj;
	}
	
	public function UpdateSection($CompanyID, $AutoNo, $Section)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateSection(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'Section' => $Section))->UpdateSectionResult);

		return $resultObj;
	}
		
	public function GetDayType($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetDayType(array('CompanyID' => $CompanyID))->GetDayTypeResult);
		return $resultObj;
	}
	
	public function UpdateDayType($CompanyID, $AutoNo, $DayType, $PeriodicTotal, $WorkRate, $OTRate, $DiffOTRate)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateDayType(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'DayType' => $DayType, 'PeriodicTotal' => $PeriodicTotal, 'WorkRate' => $WorkRate, 'OTRate' => $OTRate, 'DiffOTRate' => $DiffOTRate))->UpdateDayTypeResult);

		return $resultObj;
	}
	
	public function GetRemark($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetRemark(array('CompanyID' => $CompanyID))->GetRemarkResult);
		return $resultObj;
	}
	
	public function AddRemark($CompanyID, $Remark, $WorkCode)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddRemark(array('CompanyID' => $CompanyID, 'Remark' => $Remark, 'WorkCode' => $WorkCode))->AddRemarkResult);

		return $resultObj;
	}
	
	public function UpdateRemark($CompanyID, $AutoNo, $Remark, $WorkCode)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->UpdateRemark(array('CompanyID' => $CompanyID, 'AutoNo' => $AutoNo, 'Remark' => $Remark, 'WorkCode' => $WorkCode))->UpdateRemarkResult);

		return $resultObj;
	}
		
	public function GetAllHoliday($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetAllHoliday(array('CompanyID' => $CompanyID, 'DateFrom' => $CheckTimeFrom, 'DateTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAllHolidayResult);
		return $resultObj;
	}
	
	public function GetBranchHoliday($CompanyID, $Branch, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetBranchHoliday(array('CompanyID' => $CompanyID, 'Branch' => $Branch, 'DateFrom' => $CheckTimeFrom, 'DateTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetBranchHolidayResult);
		return $resultObj;
	}
	
	public function GetGroupDutyRoster($CompanyID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetGroupDutyRoster(array('CompanyID' => $CompanyID, 'DateFrom' => $CheckTimeFrom, 'DateTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetGroupDutyRosterResult);
		return $resultObj;
	}
	
	public function GetUserDutyRoster($CompanyID, $UserID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->GetUserDutyRoster(array('CompanyID' => $CompanyID, 'UserID' => $UserID, 'DateFrom' => $CheckTimeFrom, 'DateTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetUserDutyRosterResult);
		return $resultObj;
	}
	
	public function GetOrgStructure($CompanyID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetOrgStructure(array('CompanyID' => $CompanyID))->GetOrgStructureResult);
		return $resultObj;
	}
	
	public function GetOrgStructureHoliday($CompanyID, $DivisionID, $CheckTimeFrom, $CheckTimeTo, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetOrgStructureHoliday(array('CompanyID' => $CompanyID, 'DivisionID' => $DivisionID, 'DateFrom' => $CheckTimeFrom, 'DateTo' => $CheckTimeTo, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetOrgStructureHolidayResult);
		return $resultObj;
	}
	
	public function GetAuditDataByDate($CompanyID, $CheckTimeDate, $RecordStartFrom, $LimitRecordShow)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetAuditDataByDate(array('CompanyID' => $CompanyID, 'CheckTimeDate' => $CheckTimeDate, 'RecordStartFrom' => $RecordStartFrom, 'LimitRecordShow' => $LimitRecordShow))->GetAuditDataByDateResult);
		return $resultObj;
	}
	
	public function GetAuditDataCount($CompanyID, $CheckTimeDate)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->GetAuditDataCount(array('CompanyID' => $CompanyID, 'CheckTimeDate' => $CheckTimeDate))->GetAuditDataCountResult);
		return $resultObj;
	}
	
	public function AddOrgStructure($CompanyID, $ParentID, $Division, $DivisionType, $CompanyRegistrationID, $Email, $PhoneNo, $FaxNo, $Address, $CountryCode, $CurrencySymbol)
	{				
		$this->setHeader();
		$resultObj = json_decode($this->client->AddOrgStructure(array('CompanyId' => $CompanyID, 'ParentId' => $ParentID,'Division' => $Division, 'DivisionType' => $DivisionType,'CompanyRegistrationId' => $CompanyRegistrationID, 'Email' => $Email,'PhoneNo' => $PhoneNo, 'FaxNo' => $FaxNo, 'Address' => $Address,'CountryCode' => $CountryCode, 'CurrencySymbol' => $CurrencySymbol))->AddOrgStructureResult);
		return $resultObj;
	}
	
	public function AddOrgStructure2($CompanyID, $JsonOrgStructureInfo)
	{
		$this->setHeader();
		
		$resultObj = json_decode($this->client->AddOrgStructure2(array('CompanyID' => $CompanyID, 'JSONOrgStructureInfo' => $JsonOrgStructureInfo))->AddOrgStructure2Result);

		return $resultObj;
	}
	
	public function UpdateOrgStructure($CompanyID, $ParentID, $ID, $Division, $CompanyRegistrationID, $Email, $PhoneNo, $FaxNo, $Address, $CountryCode, $CurrencySymbol)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->UpdateOrgStructure(array('CompanyId' => $CompanyID, 'ParentId' => $ParentID,'Id' => $ID,'Division' => $Division, 'CompanyRegistrationId' => $CompanyRegistrationID, 'Email' => $Email,'PhoneNo' => $PhoneNo, 'FaxNo' => $FaxNo,'Address' => $Address,'CountryCode' => $CountryCode, 'CurrencySymbol' => $CurrencySymbol))->UpdateOrgStructureResult);
		return $resultObj;
	}
	
	public function UpdateOrgStructure2($CompanyID, $JsonOrgStructureInfo)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->UpdateOrgStructure2(array('CompanyID' => $CompanyID, 'JSONOrgStructureInfo' => $JsonOrgStructureInfo))->UpdateOrgStructure2Result);
		return $resultObj;
	}
	
	public function DeleteOrgStructure($CompanyID, $ID)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->DeleteOrgStructure(array('CompanyId' => $CompanyID, 'Id' => $ID))->DeleteOrgStructureResult);
		return $resultObj;
	}
	
	public function DeleteOrgStructure2($CompanyID, $JsonOrgStructureInfo)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->DeleteOrgStructure2(array('CompanyID' => $CompanyID, 'JSONOrgStructureInfo' => $JsonOrgStructureInfo))->DeleteOrgStructure2Result);
		return $resultObj;
	}
	
	public function AssignOrgStructure($CompanyID, $JsonOrgStructureInfo)
	{
		$this->setHeader();
		$resultObj = json_decode($this->client->AssignOrgStructure(array('CompanyID' => $CompanyID, 'JSONOrgStructureInfo' => $JsonOrgStructureInfo))->AssignOrgStructureResult);
		return $resultObj;
	}
	
	// SET FUNCTION
	public function setSecurityToken($value)
	{
		$this->securityToken = $value;
	}
	public function setStatus($value)
	{
		$this->status = $value;
	}
	public function setUserInfoObj($value)
	{
		$this->UserInfoObj = $value;
	}
	public function setUsersObj($value)
	{
		$this->setUsersObj = $value;
	}
	public function setLicenseObj($value)
	{
		$this->LicenseObj = $value;
	}
	public function setTerminalUserInfoObj($value)
	{
		$this->TerminalUserInfoObj = $value;
	}
	public function setAllTerminalUserInfoObj($value)
	{
		$this->AllTerminalUserInfoObj = $value;
	}
	public function setLogObj($value)
	{
		$this->LogObj = $value;
	}
	public function setAllLogsObj($value)
	{
		$this->AllLogsObj = $value;
	}
	public function setTerminalInfoObj($value)
	{
		$this->TerminalInfoObj = $value;
	}
	public function setApiLimitObj($value)
	{
		$this->ApiLimitObj = $value;
	}
	public function setFingerprintObj($value)
	{
		$this->FingerprintObj = $value;
	}
	public function setAuditDataObj($value)
	{
		$this->AuditDataObj = $value;
	}
	public function setCompanyID($value)
	{
		$this->CompanyID = $value;
	}
	public function setApprovedSumWorkingHourObj($value)
	{
		$this->ApprovedSumWorkingHourObj = $value;
	}
	public function setAttendanceObj($value)
	{
		$this->AttendanceObj = $value;
	}
	public function setApprovedAttendanceObj($value)
	{
		$this->ApprovedAttendanceObj = $value;
	}
	public function setAllAttendanceObj($value)
	{
		$this->AllAttendanceObj = $value;
	}
	public function setAllApprovedAttendanceObj($value)
	{
		$this->AllApprovedAttendanceObj = $value;
	}
	public function setAttendanceJobCostObj($value)
	{
		$this->AttendanceJobCostObj = $value;
	}
	public function setAllAttendanceJobCostObj($value)
	{
		$this->AllAttendanceJobCostObj = $value;
	}
	public function setLeaveTypeObj($value)
	{
		$this->LeaveTypeObj = $value;
	}
	public function setUserLeaveObj($value)
	{
		$this->UserLeaveObj = $value;
	}
	public function setScheduleObj($value)
	{
		$this->ScheduleObj = $value;
	}
	public function setAllScheduleObj($value)
	{
		$this->AllScheduleObj = $value;
	}
	public function setCompanySettingObj($value)
	{
		$this->CompanySettingObj = $value;
	}
	
	
	
	// GET FUNCTION
	public function getSecurityToken()
	{
		return $this->securityToken;
	}
	
	public function getStatus()
	{
		return $this->status;
	}
}


	
?>
